#ifndef DEVICES_TIMER_H
#define DEVICES_TIMER_H 1
/*
**	$VER: timer.h 36.16 (25.1.91)
**	Includes Release 40.15
**
**	Timer device name and useful definitions.
**
**	(C) Copyright 1985-1993 Commodore-Amiga Inc.
**		All Rights Reserved
*/

#include <exec/types.h>
#include <exec/io.h>

/* This is somewhat misleading.  It's really not a GNU C dependency,
   it is a dependency on using ixemul.library and the associated libc.a
   and include files.  But there is currently no easy way to differentiate
   the use of GNU C from the intent to use ixemul.library.   -fnf */

#ifdef __GNUC__
#include <sys/time.h>
#endif

/* unit defintions */
#define UNIT_MICROHZ	0
#define UNIT_VBLANK	1
#define UNIT_ECLOCK	2
#define UNIT_WAITUNTIL	3
#define	UNIT_WAITECLOCK	4

#define TIMERNAME	"timer.device"

#ifndef __GNUC__

struct timeval {
    ULONG tv_secs;
    ULONG tv_micro;
};

#else

/* Use the definition in sys/time.h */
#define tv_secs  tv_sec
#define tv_micro tv_usec

#endif

struct EClockVal {
    ULONG ev_hi;
    ULONG ev_lo;
};

struct timerequest {
    struct IORequest tr_node;
    struct timeval tr_time;
};

/* IO_COMMAND to use for adding a timer */
#define TR_ADDREQUEST	CMD_NONSTD
#define TR_GETSYSTIME	(CMD_NONSTD+1)
#define TR_SETSYSTIME	(CMD_NONSTD+2)

#endif /* DEVICES_TIMER_H */
